#!/usr/bin/python
# -*-coding: utf-8-*-

import math

# Programm 5.4a
# zur Bereitstellung des 2. Differenzenquotienten
#   f2(a,h) = (y2 - 2 y1 + y0)/h^2 
#      (2. Differenzenquotient einer Funktion f0 an der Stelle a)
# Funktion f0 und Punkt a sind gegeben
# function [y2] = f2(a,h);
def f2(a,h):
    y2 = (f0(a+h) - 2*f0(a) + f0(a-h))/(h*h)
    return y2
# endfunction

# Programm 5.4b
# zur Bereitstellung einer Funktion f0
# function [y] = f0(x);
def f0(x):
    y = math.sin(x)
    return y
# endfunction

# Programm 5.3
# zur sukzessiven Berechnung der Stuetzkoeffizienten
# fuer die Polynomappr. fuer die Stuetzpunkte (x_0,y_0),...,(x_n,y_n)
# und Polynomwert-Berechnung mit der baryzentrischen Formel
# input:  Vektoren x(1:n+1), y(1:n+1), Stelle xx
# output: Wert des Lagrange-Polynoms p_n(xx)
# Aufruf: [fwert] = lagrangebaryip_gb(xx,x,y)
# function [fwert] = lagrangebaryip_gb(xx,x,y)
def lagrangebaryip_gb(xx,x,y):
    n = len(x)-1
# Start mit lamm_0
    lambd = list(range(0,n+1))
    lambd[0] = 1 # lamm(1) = 1;
    for k in range(1,n+1): # k=1:n
        summe = 0.0
# Berechnung der Stuetzkoeffizienten
        for i in range(0,k): #  i=0:k-1
            lambd[i] = lambd[i]/(x[i]-x[k])
            summe = summe + lambd[i]
#       endfor
        lambd[k] = -summe
# Berechnung des Interpolationspolynoms an der Stelle xx
        summe = 0.0; zaehler = 0.0
        for i in range(0,k+1): # i=0:k
            mue = lambd[i]/(xx-x[i]);
            summe = summe + mue
            zaehler = zaehler + mue*y[i];
#       endfor
#   endfor
# Polynomwert mit der baryzentrischen Formel an der Stelle xx
    fwert = zaehler/summe
    return fwert
# endfunction

# Programm 5.4
# Extrapolation der numerischen Ableitung f2 der Funktion f0
# an der Stelle a
# input:  h(1:n+1) als Vektor des R^(n+1)$ mit paarweise
#         verschiedenen Komponenten, Funktion f2(a,h), a
# output: extrapolierte Wert der Ableitung
# benutzte Programme: lagrangebaryip_gb, f2, f0
# Aufruf: fwert = extrap_f2_gb(h,a)
# function [fwert] = extrap_f2_gb(h,a);
def extrap_f2_gb(h,a):
    n = len(h)-1
    y = np.zeros(n+1) # y = list(range(0,n+1))
    for k in range(0,n+1): # k=0:n
        y[k] = f2(a,h[k]) # y(k+1) = f2(a,h(k+1))
#   endfor
    fwert = lagrangebaryip_gb(0,h,y)
    return fwert
# endfunction
