#!/usr/bin/python
# -*-coding: utf-8-*-

import math

# Nutzer-Funktion
# exakter Wert von \int_0^1 4/(x*x+1) dx ist pi
def fkt61(x):
    y = 4/(x*x+1)
    return y
#   endfunction

# Programm 6.2
# Gauss-Tschebyscheff-Quadratur
# \int_a^b fkt61(x) dx 
# input:  Intervallgrenzen a,b, Stuetzstellenzahl n
# output: Wert des Integrals
# benutzte Funktion: fkt61
# Aufruf: [integralwert] = gausstscheby_gb(a,b,n)

def gausstscheby_gb(a,b,n):
    integral = 0
    x = list(range(0,n)); t = list(range(0,n))
    for j in range(0,n):
        x[j] = math.cos(((2*(j+1)-1)*math.pi)/(2*n))
#       Transformation der Integrationsgrenzen von[a,b] auf [-1,1]
	t[j] = (b+a)/2 + x[j]*(b-a)/2;
        integral = integral + fkt61(t[j])*math.sqrt(1-x[j]*x[j])
#   endfor
    integralwert = integral*math.pi*(b-a)/(2*n)
    return integralwert
#   endfunction

def main():
    a = 0
    b = 1
    n = 285

    iw = gausstscheby_gb(a,b,n)

    print(iw)
    print(math.pi)

if __name__ == '__main__':
    main()


