#!/usr/bin/python
# -*-coding: utf-8-*-

import math
import numpy as np

# Programm 4.1 zur Transfomation von a auf Hessenberg-Form
# input:  Matrix a0=(a0_{ij}) vom Typ n x n
# output: Hessenberg-Matrix h, orthogonale Matrix q^T
# Aufruf: [h,qt] = hessenberg_gb0(a)
# function [h,qt] = hessenberg_gb(a0);

def hessenberg_gb(a0):
    n = len(a0)
#
    a = np.zeros((n,2*n)) # a = [[0 for col in range(col)] for row in range(row)]
#    
    h = np.zeros((n,n)) # h = [[0 for col in range(col)] for row in range(row)]
    qt = np.zeros((n,n)) #qt = [[0 for col in range(col)] for row in range(row)]
    
    for j in range(0,n):
        for k in range(0,n):
            a[j,k] = a0[j,k]
#       endfor
#   endfor
# Aufbau des erweiterten Schemas [A|E]
# Endergebnis [H|Q^T]
    for i in range(0,n): # i=1:n
        for j in range(0,n): # j=1:n
            if (i == j):
                a[i,n+j]=1
            else:
                a[i,n+j]=0
#           endif
#       endfor
#   endfor
# Erzeugung des unteren Null-Dreiecks
    for j in range(0,n-2): # j=1:n-2
        summe=0
        for k in range(j+1,n): #  k=j+1:n
            summe=summe+a[k][j]*a[k][j]
#       endfor
        c = np.sign(a[j+1,j])*math.sqrt(summe)
        if (c != 0):
            a[j+1,j]=c+a[j+1,j]
            d=1/(c*a[j+1,j]);
# Linksmultiplikation mit H_j
            for k in range(j+1,2*n): #   k=j+1:2*n
                summe=0
                for i in range(j+1,n): # i=j+1:n
                    summe=summe+a[i,j]*a[i,k]
#               endfor
                e=d*summe
                for i in range(j+1,n): # i=j+1:n
                    a[i,k]=a[i,k]-e*a[i,j]
#               endfor
#           endfor
# Rechtsmultiplikation mit H_j
            for i in range(0,n): # i=1:n
                summe=0
                for k in range(j+1,n): # k=j+1:n
                    summe=summe+a[i,k]*a[k,j]
#               endfor
                e=d*summe;
                for k in range(j+1,n): #  k=j+1:n
                    a[i,k]=a[i,k]-e*a[k,j]
#               endfor
#           endfor
# update von a(j+1,j)...a(n,j)
            a[j+1,j]=-c
            for i in range(j+2,n): #  i=j+2:n
                a[i,j]=0
#           endfor
#       endif
#   endfor
    for i in range(0,n):
        for k in range(0,n):
            h[i,k] = a[i,k]
            qt[i,k] = a[i,k+n]
#       endfor
#   endfor            
    return (h, qt)
#endfunction
