#!/usr/bin/python
# -*-coding: utf-8-*-

import math
import numpy as np

# Programm 7.4 zur Jacobi-Iteration (jacobiit_gb.m)
# input:  Diagonalen l,d,u der Koeffizientenmatrix a, l(1) und u(n) sind dummy-Werte
#         rechte Seite b
# output: Loesung x
# Aufruf: [x] = jacobiit_gb(l,d,u,b)

def jacobiit_gb(l,d,u,b):
    n = len(d);
    xdiff = 1.0; xnorm = 1.0; it = 0
    x = [0 for k in range(n)]
    xneu = [0 for k in range(n)]
    while (math.sqrt(xdiff/xnorm) > 1.0e-9):
        xneu[0] = (b[0] - u[0]*x[1])/d[0]
        for k in range(1,n-1):
            xneu[k] = (b[k] - l[k]*x[k-1] - u[k]*x[k+1])/d[k]
#       endfor
        xneu[n-1] = (b[n-1] - l[n-1]*x[n-2])/d[n-1]
        xdiff = 0; xnorm = 0
        for k in range(n):
            xdiff = xdiff + math.pow((xneu[k]-x[k]),2)
            x[k] = xneu[k]
            xnorm = xnorm + math.pow(x[k],2)
#       endfor
        print("xdiff=",xdiff)
        if (xnorm == 0):
            xnorm = 1.0
#       endif
        it = it +1
#   endwhile
    return (x,it)
# endfunction

def main():
    l = -np.ones(9)
    d = 2*np.ones(9)
    u = -np.ones(9)
    b = np.zeros(9)
    b[0] = 1
    b[8] = 1

    x, it = jacobiit_gb(l,d,u,b)

    print(x)
    print(it)

if __name__ == '__main__':
    main()

