#!/usr/bin/python
# -*-coding: utf-8-*-

import numpy as np

# Programm 5.3
# zur sukzessiven Berechnung der Stuetzkoeffizienten
# fuer die Polynomappr. fuer die Stuetzpunkte (x_0,y_0),...,(x_n,y_n)
# und Polynomwert-Berechnung mit der baryzentrischen Formel
# input:  Vektoren x(1:n+1), y(1:n+1), Stelle xx
# output: Wert des Lagrange-Polynoms p_n(xx)
# Aufruf: [fwert] = lagrangebaryip_gb(xx,x,y)
# function [fwert] = lagrangebaryip_gb(xx,x,y)
def lagrangebaryip_gb(xx,x,y):
    n = len(x)-1
# Start mit lamm_0
    lambd = list(range(0,n+1))
    lambd[0] = 1 # lamm(1) = 1;
    for k in range(1,n+1): # k=1:n
        summe = 0.0
# Berechnung der Stuetzkoeffizienten
        for i in range(0,k): #  i=0:k-1
            lambd[i] = lambd[i]/(x[i]-x[k])
            summe = summe + lambd[i]
#       endfor
        lambd[k] = -summe
# Berechnung des Interpolationspolynoms an der Stelle xx
        summe = 0.0; zaehler = 0.0
        for i in range(0,k+1): # i=0:k
            mue = lambd[i]/(xx-x[i]);
            summe = summe + mue
            zaehler = zaehler + mue*y[i];
#       endfor
#   endfor
# Polynomwert mit der baryzentrischen Formel an der Stelle xx
    fwert = zaehler/summe
    return fwert
# endfunction

def main():
    x = np.array([1,2,3,4,5])
    y = np.array([0,2,3,2,1])
    xx = 3.5

    fwert = lagrangebaryip_gb(xx,x,y)

    print(fwert)

if __name__ == '__main__':
    main()

