#!/usr/bin/python
# -*-coding: utf-8-*-

import numpy as np

# Programm 5.1 Lagrange-Interpolation
# Berechnung des Polynomwerts p_n(xx) des Lagrange-Polynoms
# fuer die Stuetzpunkte (x_0,y_0),...,(x_n,y_n)
# input:  Vektoren x(1:n+1), y(1:n+1), Stelle xx
# output: Polynomwert p_n(xx)
# Aufruf: [fwert] = lagrangeip_gb(xx,x,y);
# function [fwert] = lagrangeip_gb(xx,x,y);
def lagrangeip_gb(xx,x,y):
    n=len(x)-1 #:  length(x)-1;
    l = list(range(0,n+1))
# Konstruktion der Lagrange-Basispoylnome l_0,l_1,...,l_n
# bei den Stuetzwerten x_0,x_1,...,x_n (=Vektor x(1:n+1)) 
# an der Stelle xx
    for k in range(0,n+1): #  k=0:n
        faktor=1
        for i in range(0,n+1): # i=0:n
            if (i != k):
                faktor = faktor*(xx-x[i])/(x[k] - x[i])
#           endif
#       endfor
        l[k] = faktor
#   endfor
# Polynomwertberechnung p_n(xx)
# bei den Werten y_0,y_1,...,y_n (=Vektor y(1:n+1))
    fwert=0
    for i in range(0,n+1): #  i=0:n
        fwert = fwert + l[i]*y[i]
#   endfor
    return fwert
# endfunction

def main():
    x = np.array([1,2,3,4,5])
    y = np.array([0,2,3,2,1])
    xx = 3.5

    fwert = lagrangeip_gb(xx,x,y)

    print(fwert)

if __name__ == '__main__':
    main()

