#!/usr/bin/python
# -*-coding: utf-8-*-

import numpy as np

# Programm 5.2 Newton-Interpolation,  
# Berechnung des Polynomwerts p_n(xx) des Newtonschen Interpolations-Polynoms
# fuer die Stuetzpunkte (x_0,y_0),...,(x_n,y_n)
# input:  Vektoren x(1:n+1), y(1:n+1), Stelle xx
# output: Polynomwert p_n(xx)
# Aufruf: fwert = newtonip_gb(xx,x,y);
# function [fwert] = newtonip_gb(xx,x,y);
def newtonip_gb(xx,x,y):
    n=len(x)-1
    d = list(range(0,n+1))
# dividierte Differenzen d_0,d_1,...,d_n
    for i in range(0,n+1): #  i=0:n
        d[i] = y[i] # d(i+1)=y(i+1);
#   endfor
    for k in range(1,n+1): #  k=1:n
        for l in range(k,n+1): # i=n:-1:k
            i = n+k-l
            d[i] = (d[i-1] - d[i])/(x[i-k] - x[i])
#       endfor
#   endfor
# Polynomwertberechnung p_n(xx) mit dem Horner-Schema
    fwert=d[n] # d(n+1);
    for l in range(0,n): # i=n-1:-1:0
        i = n-1 - l
        fwert = d[i] + (xx - x[i])*fwert
#   endfor
    return fwert
# endfunction

def main():
    x = np.array([1,2,3,4,5])
    y = np.array([0,2,3,2,1])
    xx = 3.5

    fwert = newtonip_gb(xx,x,y)

    print(fwert)

if __name__ == '__main__':
    main()

