#!/usr/bin/python
# -*-coding: utf-8-*-

import numpy as np
import math

# Programm 3.1 zur QR-Zerlegung einer Matrix c0 = q*r
# Erzeugung der wesentlichen Informationen fuer 
# die orthogonale Matrix Q und der oberen Dreiecksmatrix R
# input:  Matrix c=(c(ij)) vom Typ m x p gegeben (m >= p)
# output: Matrix c mit den wesentlichen Informationen
#         der orthogonalen Matrix q und der oberen Dreiecksmatrix r,
#         Erzeugung des inputs fuer das Programm bestapprqr_gb.m,
# Aufruf: [c,t] = qr_gb(c);

def qr_gb(c0):
    m = len(c0)
    p = len(c0[0])
    c = np.zeros((m,p))
    t = np.zeros(p)
    for i in range(m):
        for j in range(p):
            c[i,j] = c0[i,j]
    for l in range(0,p): # mslice[1:p]:
        gamma = 0
        for i in range(l,m): # mslice[l:m]:
            gamma = gamma + c[i,l]*c[i,l]
#       endfor
        gamma = math.sqrt(gamma)
        if (c[l,l] < 0):
            gamma = -gamma
#       endif
        peta = math.sqrt(2*gamma*(gamma + c[l,l]))
        t[l] = -gamma #        t(l).lvalue = -gamma
        c[l,l] = (c[l,l] + gamma)/peta #        c(l, l).lvalue = (c(l, l) + gamma) / peta
        for k in range(l+1,m): # mslice[l + 1:m]:
            c[k,l] = c[k,l]/peta # c(k, l).lvalue = c(k, l) / peta
#       endfor
        for j in range(l+1,p): # mslice[l + 1:p]:
            g = 0
            for k in range(l,m): # mslice[l:m]:
                g = g + c[k,l]*c[k,j]
#           endfor
            g = g + g
            for i in range(l,m): # mslice[l:m]:
                c[i,j] = c[i,j] - g*c[i,l] # c(i, j).lvalue = c(i, j) - g * c(i, l)
#           endfor
#       endfor
#   endfor
    return (c, t)
#   endfunction
