#!/usr/bin/python
# -*-coding: utf-8-*-

import numpy as np
import math
import matplotlib.pyplot as plt

# Programm 10.4 stoch_int_gb.m : Ito- und Stratonowitsch-Integral
#              /                                / 
# Ito Integral | W dW , Stratonowitsch Integral | W o dW
#              /                                /

np.random.seed(60) # random seeding
T = 1 ; N = 5000 ; dt = T/N
dW = np.zeros(N); W = np.zeros(N); ito = np.zeros(N-1)
Xito = np.zeros(N); strat = np.zeros(N)
dW = np.dot(math.sqrt(dt),np.random.randn(N))  # Inkremente
W = np.cumsum(dW)  # approximierter Pfad eines Wiener-Prozess
#
wh = np.zeros(N)
for j in range(0,N-1):
    wh[0] = 0
    for i in range(0,j+1):
        wh[i+1] = W[i]
#   endfor
    ito[j] = np.dot(wh[0:j+2],dW[0:j+2])
# endfor
Xito[0] = 0
for j in range(1,N):
    Xito[j] = ito[j-1]
# endfor
#
strat[0] = 0.5*W[0]*dW[0]
for j in range(1,N):
    strato = 0
    for i in range(1,j+1):
        strato = strato + 0.5*(W[i-1]+W[i])*dW[i]
#   endfor
    strat[j] = strato
# endfor
tt = np.zeros(N)
for i in range(N):
    tt[i] = (i+1)*dt
# endfor
fig = plt.figure(1)
plt.plot(tt, W, 'r-')
#
fig = plt.figure(2)
plt.plot(tt, Xito, 'g-')
#
fig = plt.figure(3)
plt.plot(tt, strat, 'b-')

itoerr = abs(Xito[N-1] - 0.5*(W[N-1]*W[N-1]-T))
straterr = abs(strat[N-1] - 0.5*W[N-1]*W[N-1])
